diff -uNr fwbuilder-2.1.8/src/gui/iptadvanceddialog_q.ui fwbuilder-2.1.9/src/gui/iptadvanceddialog_q.ui
--- fwbuilder-2.1.8/src/gui/iptadvanceddialog_q.ui	2006-06-01 08:26:53.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/iptadvanceddialog_q.ui	2007-01-15 05:37:52.000000000 +0100
@@ -12,7 +12,7 @@
             <x>0</x>
             <y>0</y>
             <width>677</width>
-            <height>660</height>
+            <height>699</height>
         </rect>
     </property>
     <property name="sizePolicy">
@@ -139,51 +139,7 @@
                             <set>AlignVCenter|AlignRight</set>
                         </property>
                     </widget>
-                    <spacer row="16" column="1">
-                        <property name="name">
-                            <cstring>spacer26</cstring>
-                        </property>
-                        <property name="orientation">
-                            <enum>Vertical</enum>
-                        </property>
-                        <property name="sizeType">
-                            <enum>Expanding</enum>
-                        </property>
-                        <property name="sizeHint">
-                            <size>
-                                <width>20</width>
-                                <height>20</height>
-                            </size>
-                        </property>
-                    </spacer>
-                    <spacer row="15" column="0">
-                        <property name="name">
-                            <cstring>spacer10_3</cstring>
-                        </property>
-                        <property name="orientation">
-                            <enum>Horizontal</enum>
-                        </property>
-                        <property name="sizeType">
-                            <enum>Fixed</enum>
-                        </property>
-                        <property name="sizeHint">
-                            <size>
-                                <width>30</width>
-                                <height>50</height>
-                            </size>
-                        </property>
-                    </spacer>
-                    <widget class="QCheckBox" row="15" column="1" rowspan="1" colspan="2">
-                        <property name="name">
-                            <cstring>mgmt_ssh</cstring>
-                        </property>
-                        <property name="text">
-                            <string>Always permit ssh access from
-the management workstation
-with this address:</string>
-                        </property>
-                    </widget>
-                    <widget class="QCheckBox" row="6" column="1" rowspan="1" colspan="5">
+                    <widget class="QCheckBox" row="6" column="1" rowspan="1" colspan="4">
                         <property name="name">
                             <cstring>acceptESTBeforeFirst</cstring>
                         </property>
@@ -199,7 +155,7 @@
                             <string>Accept ESTABLISHED and RELATED packets before the first rule</string>
                         </property>
                     </widget>
-                    <widget class="QCheckBox" row="8" column="1" rowspan="1" colspan="5">
+                    <widget class="QCheckBox" row="8" column="1" rowspan="1" colspan="4">
                         <property name="name">
                             <cstring>bridge</cstring>
                         </property>
@@ -232,7 +188,7 @@
                             </size>
                         </property>
                     </spacer>
-                    <widget class="QCheckBox" row="9" column="1" rowspan="1" colspan="5">
+                    <widget class="QCheckBox" row="9" column="1" rowspan="1" colspan="4">
                         <property name="name">
                             <cstring>shadowing</cstring>
                         </property>
@@ -248,7 +204,7 @@
                             <string>Detect shadowing in policy rules</string>
                         </property>
                     </widget>
-                    <widget class="QCheckBox" row="4" column="1" rowspan="1" colspan="5">
+                    <widget class="QCheckBox" row="4" column="1" rowspan="1" colspan="4">
                         <property name="name">
                             <cstring>assumeFwIsPartOfAny</cstring>
                         </property>
@@ -264,7 +220,7 @@
                             <string>Assume firewall is part of 'any'</string>
                         </property>
                     </widget>
-                    <widget class="QCheckBox" row="5" column="1" rowspan="1" colspan="5">
+                    <widget class="QCheckBox" row="5" column="1" rowspan="1" colspan="4">
                         <property name="name">
                             <cstring>acceptSessions</cstring>
                         </property>
@@ -280,23 +236,7 @@
                             <string>Accept TCP sessions opened prior to firewall restart</string>
                         </property>
                     </widget>
-                    <widget class="QCheckBox" row="12" column="1" rowspan="1" colspan="5">
-                        <property name="name">
-                            <cstring>clampMSStoMTU</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>Clamp MSS to MTU</string>
-                        </property>
-                    </widget>
-                    <widget class="QCheckBox" row="11" column="1" rowspan="1" colspan="5">
+                    <widget class="QCheckBox" row="11" column="1" rowspan="1" colspan="4">
                         <property name="name">
                             <cstring>localNAT</cstring>
                         </property>
@@ -312,22 +252,6 @@
                             <string>Enable support for NAT of locally originated connections</string>
                         </property>
                     </widget>
-                    <widget class="QCheckBox" row="10" column="1" rowspan="1" colspan="5">
-                        <property name="name">
-                            <cstring>emptyGroups</cstring>
-                        </property>
-                        <property name="sizePolicy">
-                            <sizepolicy>
-                                <hsizetype>1</hsizetype>
-                                <vsizetype>0</vsizetype>
-                                <horstretch>0</horstretch>
-                                <verstretch>0</verstretch>
-                            </sizepolicy>
-                        </property>
-                        <property name="text">
-                            <string>Ignore empty groups in rules</string>
-                        </property>
-                    </widget>
                     <widget class="QLabel" row="0" column="0" rowspan="1" colspan="3">
                         <property name="name">
                             <cstring>compilerLabel</cstring>
@@ -358,9 +282,40 @@
                             <set>WordBreak|AlignVCenter</set>
                         </property>
                     </widget>
-                    <spacer row="13" column="5">
+                    <widget class="Line" row="3" column="0" rowspan="1" colspan="5">
                         <property name="name">
-                            <cstring>spacer30</cstring>
+                            <cstring>line4_2</cstring>
+                        </property>
+                        <property name="frameShape">
+                            <enum>HLine</enum>
+                        </property>
+                        <property name="frameShadow">
+                            <enum>Sunken</enum>
+                        </property>
+                        <property name="orientation">
+                            <enum>Horizontal</enum>
+                        </property>
+                    </widget>
+                    <widget class="QCheckBox" row="7" column="1" rowspan="1" colspan="2">
+                        <property name="name">
+                            <cstring>dropInvalid</cstring>
+                        </property>
+                        <property name="text">
+                            <string>Drop packets that are associated with
+no known connection</string>
+                        </property>
+                    </widget>
+                    <widget class="QCheckBox" row="7" column="3">
+                        <property name="name">
+                            <cstring>logInvalid</cstring>
+                        </property>
+                        <property name="text">
+                            <string>and log them</string>
+                        </property>
+                    </widget>
+                    <spacer row="7" column="4">
+                        <property name="name">
+                            <cstring>spacer83</cstring>
                         </property>
                         <property name="orientation">
                             <enum>Horizontal</enum>
@@ -370,41 +325,110 @@
                         </property>
                         <property name="sizeHint">
                             <size>
-                                <width>72</width>
+                                <width>80</width>
                                 <height>20</height>
                             </size>
                         </property>
                     </spacer>
-                    <widget class="QComboBox" row="13" column="2" rowspan="1" colspan="3">
+                    <widget class="QLineEdit" row="2" column="3" rowspan="1" colspan="2">
                         <property name="name">
-                            <cstring>actionOnReject</cstring>
+                            <cstring>outputFileName</cstring>
+                        </property>
+                        <property name="maximumSize">
+                            <size>
+                                <width>32767</width>
+                                <height>32767</height>
+                            </size>
                         </property>
                     </widget>
-                    <widget class="QLabel" row="13" column="1">
+                    <widget class="QLineEdit" row="1" column="3" rowspan="1" colspan="2">
                         <property name="name">
-                            <cstring>textLabel9</cstring>
+                            <cstring>compilerArgs</cstring>
                         </property>
-                        <property name="text">
-                            <string>Default action on 'Reject':</string>
+                        <property name="maximumSize">
+                            <size>
+                                <width>32767</width>
+                                <height>32767</height>
+                            </size>
                         </property>
                     </widget>
-                    <widget class="Line" row="14" column="0" rowspan="1" colspan="6">
+                    <widget class="QLineEdit" row="0" column="3" rowspan="1" colspan="2">
                         <property name="name">
-                            <cstring>line4</cstring>
+                            <cstring>compiler</cstring>
                         </property>
-                        <property name="frameShape">
-                            <enum>HLine</enum>
+                        <property name="maximumSize">
+                            <size>
+                                <width>32767</width>
+                                <height>32767</height>
+                            </size>
                         </property>
-                        <property name="frameShadow">
-                            <enum>Sunken</enum>
+                    </widget>
+                    <spacer row="17" column="1">
+                        <property name="name">
+                            <cstring>spacer26</cstring>
+                        </property>
+                        <property name="orientation">
+                            <enum>Vertical</enum>
+                        </property>
+                        <property name="sizeType">
+                            <enum>Expanding</enum>
+                        </property>
+                        <property name="sizeHint">
+                            <size>
+                                <width>20</width>
+                                <height>20</height>
+                            </size>
+                        </property>
+                    </spacer>
+                    <widget class="QCheckBox" row="16" column="1" rowspan="1" colspan="2">
+                        <property name="name">
+                            <cstring>mgmt_ssh</cstring>
+                        </property>
+                        <property name="text">
+                            <string>Always permit ssh access from
+the management workstation
+with this address:</string>
+                        </property>
+                    </widget>
+                    <spacer row="16" column="0">
+                        <property name="name">
+                            <cstring>spacer10_3</cstring>
                         </property>
                         <property name="orientation">
                             <enum>Horizontal</enum>
                         </property>
+                        <property name="sizeType">
+                            <enum>Fixed</enum>
+                        </property>
+                        <property name="sizeHint">
+                            <size>
+                                <width>30</width>
+                                <height>50</height>
+                            </size>
+                        </property>
+                    </spacer>
+                    <widget class="QLineEdit" row="16" column="3" rowspan="1" colspan="2">
+                        <property name="name">
+                            <cstring>mgmt_addr</cstring>
+                        </property>
+                        <property name="sizePolicy">
+                            <sizepolicy>
+                                <hsizetype>7</hsizetype>
+                                <vsizetype>0</vsizetype>
+                                <horstretch>0</horstretch>
+                                <verstretch>0</verstretch>
+                            </sizepolicy>
+                        </property>
+                        <property name="maximumSize">
+                            <size>
+                                <width>32767</width>
+                                <height>32767</height>
+                            </size>
+                        </property>
                     </widget>
-                    <widget class="Line" row="3" column="0" rowspan="1" colspan="6">
+                    <widget class="Line" row="15" column="0" rowspan="1" colspan="5">
                         <property name="name">
-                            <cstring>line4_2</cstring>
+                            <cstring>line4</cstring>
                         </property>
                         <property name="frameShape">
                             <enum>HLine</enum>
@@ -416,26 +440,22 @@
                             <enum>Horizontal</enum>
                         </property>
                     </widget>
-                    <widget class="QCheckBox" row="7" column="1" rowspan="1" colspan="3">
+                    <widget class="QLabel" row="14" column="1">
                         <property name="name">
-                            <cstring>dropInvalid</cstring>
+                            <cstring>textLabel9</cstring>
                         </property>
                         <property name="text">
-                            <string>Drop packets that are associated with
-no known connection</string>
+                            <string>Default action on 'Reject':</string>
                         </property>
                     </widget>
-                    <widget class="QCheckBox" row="7" column="4">
+                    <widget class="QComboBox" row="14" column="2" rowspan="1" colspan="2">
                         <property name="name">
-                            <cstring>logInvalid</cstring>
-                        </property>
-                        <property name="text">
-                            <string>and log them</string>
+                            <cstring>actionOnReject</cstring>
                         </property>
                     </widget>
-                    <spacer row="7" column="5">
+                    <spacer row="14" column="4">
                         <property name="name">
-                            <cstring>spacer83</cstring>
+                            <cstring>spacer30</cstring>
                         </property>
                         <property name="orientation">
                             <enum>Horizontal</enum>
@@ -445,61 +465,49 @@
                         </property>
                         <property name="sizeHint">
                             <size>
-                                <width>80</width>
+                                <width>72</width>
                                 <height>20</height>
                             </size>
                         </property>
                     </spacer>
-                    <widget class="QLineEdit" row="15" column="3" rowspan="1" colspan="3">
+                    <widget class="QCheckBox" row="12" column="1" rowspan="1" colspan="4">
                         <property name="name">
-                            <cstring>mgmt_addr</cstring>
+                            <cstring>clampMSStoMTU</cstring>
                         </property>
                         <property name="sizePolicy">
                             <sizepolicy>
-                                <hsizetype>7</hsizetype>
+                                <hsizetype>1</hsizetype>
                                 <vsizetype>0</vsizetype>
                                 <horstretch>0</horstretch>
                                 <verstretch>0</verstretch>
                             </sizepolicy>
                         </property>
-                        <property name="maximumSize">
-                            <size>
-                                <width>32767</width>
-                                <height>32767</height>
-                            </size>
+                        <property name="text">
+                            <string>Clamp MSS to MTU</string>
                         </property>
                     </widget>
-                    <widget class="QLineEdit" row="2" column="3" rowspan="1" colspan="3">
+                    <widget class="QCheckBox" row="10" column="1" rowspan="1" colspan="4">
                         <property name="name">
-                            <cstring>outputFileName</cstring>
-                        </property>
-                        <property name="maximumSize">
-                            <size>
-                                <width>32767</width>
-                                <height>32767</height>
-                            </size>
+                            <cstring>emptyGroups</cstring>
                         </property>
-                    </widget>
-                    <widget class="QLineEdit" row="1" column="3" rowspan="1" colspan="3">
-                        <property name="name">
-                            <cstring>compilerArgs</cstring>
+                        <property name="sizePolicy">
+                            <sizepolicy>
+                                <hsizetype>1</hsizetype>
+                                <vsizetype>0</vsizetype>
+                                <horstretch>0</horstretch>
+                                <verstretch>0</verstretch>
+                            </sizepolicy>
                         </property>
-                        <property name="maximumSize">
-                            <size>
-                                <width>32767</width>
-                                <height>32767</height>
-                            </size>
+                        <property name="text">
+                            <string>Ignore empty groups in rules</string>
                         </property>
                     </widget>
-                    <widget class="QLineEdit" row="0" column="3" rowspan="1" colspan="3">
+                    <widget class="QCheckBox" row="13" column="1" rowspan="1" colspan="4">
                         <property name="name">
-                            <cstring>compiler</cstring>
+                            <cstring>makeTagClassifyTerminating</cstring>
                         </property>
-                        <property name="maximumSize">
-                            <size>
-                                <width>32767</width>
-                                <height>32767</height>
-                            </size>
+                        <property name="text">
+                            <string>Make Tag and Classify actions terminating</string>
                         </property>
                     </widget>
                 </grid>
diff -uNr fwbuilder-2.1.8/src/gui/listOfLibraries.cpp fwbuilder-2.1.9/src/gui/listOfLibraries.cpp
--- fwbuilder-2.1.8/src/gui/listOfLibraries.cpp	2006-11-09 17:13:21.000000000 +0100
+++ fwbuilder-2.1.9/src/gui/listOfLibraries.cpp	2007-02-04 05:20:26.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: listOfLibraries.cpp,v 1.19 2006/11/09 16:13:21 vkurland Exp $
+  $Id: listOfLibraries.cpp,v 1.20 2007/02/04 04:20:26 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -193,6 +193,9 @@
     if (id.isEmpty()) return end();
     if (name.isEmpty()) return end();
 
+#if 0
+    // commented out for bug #1620284
+    //
 /*
  *  mw is NULL at this point if this method is called to preload
  *  libraries on startup
@@ -213,6 +216,7 @@
             0, 1 );
         return end();
     }
+#endif
 
     if (id == STANDARD_LIB) return end();
     if (id == DELETED_LIB)  return end();
diff -uNr fwbuilder-2.1.8/src/gui/main.cpp fwbuilder-2.1.9/src/gui/main.cpp
--- fwbuilder-2.1.8/src/gui/main.cpp	2006-10-22 20:20:04.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/main.cpp	2007-02-10 23:41:00.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: main.cpp,v 1.118 2006/10/22 18:20:04 vkurland Exp $
+  $Id: main.cpp,v 1.119 2007/02/10 22:41:00 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -232,7 +232,6 @@
 
 static struct termios save_termios;
 static int            ttysavefd = -1;
-static enum { RESET, RAW, CBREAK } ttystate = RESET;
 
 int tty_raw(int fd)
 {
@@ -263,7 +262,6 @@
         exit(1);
     }
 
-    ttystate = RAW;
     ttysavefd = fd;
     return 0;
 }
